<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="formModel"
            :hidden-data="{
                id: formModel.id ?? '',
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import $helper from "~/helper.js";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";
import {useSettingStore} from "~/stores/setting.js";

const props = defineProps({
    formModel: {
        required: false,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $i18n = useI18n();
const $settingStore = useSettingStore();
const pageReady = ref(false);
const form = ref();
const model = ref();
const countries = computed(() => {
    return $settingStore.countryForOptions;
});

const formFields = computed(() => {
    return [
        {
            type: 'select',
            name: 'country_id',
            label: $i18n.t('country'),
            placeholder: $i18n.t('please_select'),
            options: countries.value,

        },
        ...Object.keys($helper.getLanguages()).map(r => {
            return {
                type: 'text',
                name: `name_${r}`,
                label: $i18n.t('name') + ' (' + $helper.getLanguages()[r].text + ')',

            };
        }),
    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/other/bank/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        if (props.formModel && props.formModel.id) {
            const data = await axios.post('/other/bank/build_form', {
                id: props.formModel ? props.formModel.id : '',
            });

            if (data.model) {
                model.value = data.model;
            }
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
